#! /bin/sh

#  Copyright (c) International Business Machines  Corp., 2002
#
#  This program is free software;  you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY;  without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
#  the GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program;  if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# 12/05/02  Port to bash -Robbie Williamson <robbiew@us.ibm.com>
# 02/05/03  Modified - Manoj Iyer <manjo@mail.utexas.edu> use USCTEST macros
#	  fixed bugs.
# 07/27/05  Michael Reed  <mreedltp@vnet.ibm.com>
#	   Made changes to account for the replacement of syslogd
#	   with syslog-ng
#
##################################################################
# case5: Test the logging option: LOG_CONS			 #
#	o Do openlog() with LOG_CONS option.		  	 #
#	o Disable /dev/syslog by moving it to a temporary file	 #
#	  name.							 #
#	o Send the syslog message.				 #
#	o Check whether this is written to the console i.e to	 #
#	  the file /usr/adm/ktlog/<this year>/<this month>/	 #
#	  <to_day>						 #
##################################################################

. syslog-lib.sh || exit 1

syslog_case5()
{
	tst_resm TINFO "syslog: Testing the log option: LOG_CONS..."

	# Create the configuration file specific to this test case.

	case "$CONFIG_FILE" in
	/etc/syslog.conf|/etc/rsyslog.conf)
		echo "$RSYSLOG_CONFIG" > $CONFIG_FILE
		echo "user.info	/var/log/messages" >> $CONFIG_FILE
		;;

	/etc/syslog-ng/syslog-ng.conf)
		echo "source src{ internal(); unix-dgram(\"/dev/log\"); udp(ip(\"0.0.0.0\") port(514)); };" > $CONFIG_FILE
		echo "filter f_syslog_user { level(info)      and facility(user); };" >> $CONFIG_FILE
		echo "destination syslog-messages { file(\"/var/log/messages\");};" >> $CONFIG_FILE
		echo "log { source(src); filter(f_syslog_user); destination(syslog-messages);};" >> $CONFIG_FILE
		;;
	esac

	restart_syslog_daemon

	# check if /var/log/messages script exists
	if [ -e /var/log/messages ]; then
		oldvalue=`grep -c "syslogtst: info to console test." /var/log/messages`
	else
		oldvalue=0
	fi

	# syslogtst does the disabling of /dev/syslog, sends the message and
	# enables /dev/syslog.
	if ! syslogtst 5 2>/dev/null; then
		cleanup 1
	fi
	sleep 2

	# check if /var/log/messages script exists
	if [ ! -e /var/log/messages ]; then
		tst_resm TBROK "/var/log/messages no such log file"
		cleanup 1
	fi
	newvalue=`grep -c "syslogtst: info to console test." /var/log/messages`

	if [ "x$(( $newvalue - $oldvalue ))" != "x1" ]; then
		status_flag=1
	fi
}

tst_resm TINFO " case5: Test the logging option: LOG_CONS"
tst_resm TINFO " o Do openlog() with LOG_CONS option."
tst_resm TINFO " o Disable /dev/syslog by moving it to a temporary file name."
tst_resm TINFO " o Send the syslog message."
tst_resm TINFO " o Check whether this is written to the console i.e to"
tst_resm TINFO "   the file /usr/adm/ktlog/<this year>/<this month>/<to_day>"

setup
syslog_case5
cleanup ${status_flag:=0}